/* 
 * This file is part of the Echo Point Project.  This project is a collection
 * of Components that have extended the Echo Web Application Framework.
 *
 * EchoPoint is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * EchoPoint is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo Point; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * This script saves and restores the scroll bar positions for a given
 * element.
 */


//---------------------------------------------------------------------------------------
// gets the position of the scroll bars as it would be should it be saved
//---------------------------------------------------------------------------------------
function ep_getScrollBarPositions(actualElement) {
	var text = actualElement.scrollLeft + "," + actualElement.scrollTop;
	return text;
}
//---------------------------------------------------------------------------------------
// saves the position of the scroll bars.  The actualElement parameter
// should be the element object as in onscroll="ep_saveScrollBarPositions('123',this);"
//---------------------------------------------------------------------------------------
function ep_saveScrollBarPositions(peerId, actualElement) {
	var text = ep_getScrollBarPositions(actualElement);
	if (E_setParameter) {
		E_setParameter(peerId,text);
	}
}



//---------------------------------------------------------------------------------------
// Scrolls the element, named by elementId,  to a given position
//---------------------------------------------------------------------------------------
function ep_ScrollTo(elementId, x, y) {
	var elem = getElementById(elementId);
	if (elem != null) {
		elem.htmlE.scrollLeft = x;
		elem.htmlE.scrollTop = y;
	}
}
